Ansible: Cleanup and speedup
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install --upgrade virtualenv || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install --upgrade -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
197     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
198     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
199     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
200     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
201     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
202     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
203     # Directories created if not present:
204     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
205     # Functions called:
206     # - die - Print to stderr and exit.
207
208     set -exuo pipefail
209
210     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
211         die "Some error during locating of this source file."
212     }
213     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
214         die "Some error during dirname call."
215     }
216     # Current working directory could be in a different repo, e.g. VPP.
217     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
218     relative_csit_dir=$(git rev-parse --show-toplevel) || {
219         die "Git rev-parse failed."
220     }
221     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
222     popd || die "Popd failed."
223     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
224         die "Readlink failed."
225     }
226     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
227         die "Readlink failed."
228     }
229     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
230         die "Readlink failed."
231     }
232     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
233         die "Readlink failed."
234     }
235     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
236         die "Readlink failed."
237     }
238
239     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
240         die "Readlink failed."
241     }
242     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
243     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
244         die "Readlink failed."
245     }
246     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
247     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
251 }
252
253
254 function compose_pybot_arguments () {
255
256     # Variables read:
257     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
258     # - DUT - CSIT test/ subdirectory, set while processing tags.
259     # - TAGS - Array variable holding selected tag boolean expressions.
260     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
261     # - TEST_CODE - The test selection string from environment or argument.
262     # Variables set:
263     # - PYBOT_ARGS - String holding part of all arguments for pybot.
264     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
265
266     set -exuo pipefail
267
268     # No explicit check needed with "set -u".
269     PYBOT_ARGS=("--loglevel" "TRACE")
270     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
271
272     case "${TEST_CODE}" in
273         *"device"*)
274             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
275             ;;
276         *"func"*)
277             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
278             ;;
279         *"perf"*)
280             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
281             ;;
282         *)
283             die "Unknown specification: ${TEST_CODE}"
284     esac
285
286     EXPANDED_TAGS=()
287     for tag in "${TAGS[@]}"; do
288         if [[ ${tag} == "!"* ]]; then
289             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
290         else
291             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
292         fi
293     done
294 }
295
296
297 function copy_archives () {
298
299     # Create additional archive if workspace variable is set.
300     # This way if script is running in jenkins all will be
301     # automatically archived to logs.fd.io.
302     #
303     # Variables read:
304     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
305     #   Can be unset, then it speeds up manual testing.
306     # - ARCHIVE_DIR - Path to directory with content to be copied.
307     # Directories updated:
308     # - ${WORKSPACE}/archives/ - Created if does not exist.
309     #   Content of ${ARCHIVE_DIR}/ is copied here.
310     # Functions called:
311     # - die - Print to stderr and exit.
312
313     set -exuo pipefail
314
315     if [[ -n "${WORKSPACE-}" ]]; then
316         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
317         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
318     fi
319 }
320
321
322 function deactivate_docker_topology () {
323
324     # Deactivate virtual vpp-device topology by removing containers.
325     #
326     # Variables read:
327     # - NODENESS - Node multiplicity of desired testbed.
328     # - FLAVOR - Node flavor string, usually describing the processor.
329
330     set -exuo pipefail
331
332     case_text="${NODENESS}_${FLAVOR}"
333     case "${case_text}" in
334         "1n_skx" | "1n_tx2")
335             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
336             ssh="ssh root@${hostname} -p 6022"
337             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
338             # The "declare -f" output is long and boring.
339             set +x
340             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
341                 die "Topology cleanup via shim-dcr failed!"
342             }
343             set -x
344             ;;
345         "1n_vbox")
346             enter_mutex || die
347             clean_environment || {
348                 die "Topology cleanup locally failed!"
349             }
350             exit_mutex || die
351             ;;
352         *)
353             die "Unknown specification: ${case_text}!"
354     esac
355 }
356
357
358 function die () {
359
360     # Print the message to standard error end exit with error code specified
361     # by the second argument.
362     #
363     # Hardcoded values:
364     # - The default error message.
365     # Arguments:
366     # - ${1} - The whole error message, be sure to quote. Optional
367     # - ${2} - the code to exit with, default: 1.
368
369     set -x
370     set +eu
371     warn "${1:-Unspecified run-time error occurred!}"
372     exit "${2:-1}"
373 }
374
375
376 function die_on_pybot_error () {
377
378     # Source this fragment if you want to abort on any failed test case.
379     #
380     # Variables read:
381     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
382     # Functions called:
383     # - die - Print to stderr and exit.
384
385     set -exuo pipefail
386
387     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
388         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
389     fi
390 }
391
392
393 function generate_tests () {
394
395     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
396     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
397     # The generation is done by executing any *.py executable
398     # within any subdirectory after copying.
399
400     # This is a separate function, because this code is called
401     # both by autogen checker and entries calling run_pybot.
402
403     # Directories read:
404     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
405     # Directories replaced:
406     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
407
408     set -exuo pipefail
409
410     rm -rf "${GENERATED_DIR}/tests" || die
411     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
412     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
413     cmd_line+=("-executable" "-name" "*.py")
414     # We sort the directories, so log output can be compared between runs.
415     file_list=$("${cmd_line[@]}" | sort) || die
416
417     for gen in ${file_list}; do
418         directory="$(dirname "${gen}")" || die
419         filename="$(basename "${gen}")" || die
420         pushd "${directory}" || die
421         ./"${filename}" || die
422         popd || die
423     done
424 }
425
426
427 function get_test_code () {
428
429     # Arguments:
430     # - ${1} - Optional, argument of entry script (or empty as unset).
431     #   Test code value to override job name from environment.
432     # Variables read:
433     # - JOB_NAME - String affecting test selection, default if not argument.
434     # Variables set:
435     # - TEST_CODE - The test selection string from environment or argument.
436     # - NODENESS - Node multiplicity of desired testbed.
437     # - FLAVOR - Node flavor string, usually describing the processor.
438
439     set -exuo pipefail
440
441     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
442     if [[ -z "${TEST_CODE}" ]]; then
443         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
444     fi
445
446     case "${TEST_CODE}" in
447         *"1n-vbox"*)
448             NODENESS="1n"
449             FLAVOR="vbox"
450             ;;
451         *"1n-skx"*)
452             NODENESS="1n"
453             FLAVOR="skx"
454             ;;
455        *"1n-tx2"*)
456             NODENESS="1n"
457             FLAVOR="tx2"
458             ;;
459         *"2n-skx"*)
460             NODENESS="2n"
461             FLAVOR="skx"
462             ;;
463         *"3n-skx"*)
464             NODENESS="3n"
465             FLAVOR="skx"
466             ;;
467         *"2n-clx"*)
468             NODENESS="2n"
469             FLAVOR="clx"
470             ;;
471         *"2n-dnv"*)
472             NODENESS="2n"
473             FLAVOR="dnv"
474             ;;
475         *"3n-dnv"*)
476             NODENESS="3n"
477             FLAVOR="dnv"
478             ;;
479         *"3n-tsh"*)
480             NODENESS="3n"
481             FLAVOR="tsh"
482             ;;
483         *)
484             # Fallback to 3-node Haswell by default (backward compatibility)
485             NODENESS="3n"
486             FLAVOR="hsw"
487             ;;
488     esac
489 }
490
491
492 function get_test_tag_string () {
493
494     # Variables read:
495     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
496     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
497     # - TEST_CODE - The test selection string from environment or argument.
498     # Variables set:
499     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
500     #   May be empty, or even not set on event types not adding comment.
501
502     # TODO: ci-management scripts no longer need to perform this.
503
504     set -exuo pipefail
505
506     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
507         case "${TEST_CODE}" in
508             *"device"*)
509                 trigger="devicetest"
510                 ;;
511             *"perf"*)
512                 trigger="perftest"
513                 ;;
514             *)
515                 die "Unknown specification: ${TEST_CODE}"
516         esac
517         # Ignore lines not containing the trigger word.
518         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}") || true
519         # The vpp-csit triggers trail stuff we are not interested in.
520         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
521         # (except relying on \s whitespace, \S non-whitespace and . both).
522         # The last string is concatenated, only the middle part is expanded.
523         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
524         # On parsing error, TEST_TAG_STRING probably stays empty.
525         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}") || true
526     fi
527 }
528
529
530 function installed () {
531
532     # Check if the given utility is installed. Fail if not installed.
533     #
534     # Duplicate of common.sh function, as this file is also used standalone.
535     #
536     # Arguments:
537     # - ${1} - Utility to check.
538     # Returns:
539     # - 0 - If command is installed.
540     # - 1 - If command is not installed.
541
542     set -exuo pipefail
543
544     command -v "${1}"
545 }
546
547
548 function reserve_and_cleanup_testbed () {
549
550     # Reserve physical testbed, perform cleanup, register trap to unreserve.
551     # When cleanup fails, remove from topologies and keep retrying
552     # until all topologies are removed.
553     #
554     # Variables read:
555     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
556     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
557     # - BUILD_TAG - Any string suitable as filename, identifying
558     #   test run executing this function. May be unset.
559     # Variables set:
560     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
561     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
562     # Functions called:
563     # - die - Print to stderr and exit.
564     # - ansible_playbook - Perform an action using ansible, see ansible.sh
565     # Traps registered:
566     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
567
568     set -exuo pipefail
569
570     while true; do
571         for topo in "${TOPOLOGIES[@]}"; do
572             set +e
573             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
574             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
575             python3 "${scrpt}" "${opts[@]}"
576             result="$?"
577             set -e
578             if [[ "${result}" == "0" ]]; then
579                 # Trap unreservation before cleanup check,
580                 # so multiple jobs showing failed cleanup improve chances
581                 # of humans to notice and fix.
582                 WORKING_TOPOLOGY="${topo}"
583                 echo "Reserved: ${WORKING_TOPOLOGY}"
584                 trap "untrap_and_unreserve_testbed" EXIT || {
585                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
586                     untrap_and_unreserve_testbed "${message}" || {
587                         die "Teardown should have died, not failed."
588                     }
589                     die "Trap attempt failed, unreserve succeeded. Aborting."
590                 }
591                 # Cleanup + calibration checks.
592                 set +e
593                 ansible_playbook "cleanup, calibration"
594                 result="$?"
595                 set -e
596                 if [[ "${result}" == "0" ]]; then
597                     break
598                 fi
599                 warn "Testbed cleanup failed: ${topo}"
600                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
601             fi
602             # Else testbed is accessible but currently reserved, moving on.
603         done
604
605         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
606             # Exit the infinite while loop if we made a reservation.
607             warn "Reservation and cleanup successful."
608             break
609         fi
610
611         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
612             die "Run out of operational testbeds!"
613         fi
614
615         # Wait ~3minutes before next try.
616         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
617             die "Sleep time calculation failed."
618         }
619         echo "Sleeping ${sleep_time}"
620         sleep "${sleep_time}" || die "Sleep failed."
621     done
622 }
623
624
625 function run_pybot () {
626
627     # Run pybot with options based on input variables. Create output_info.xml
628     #
629     # Variables read:
630     # - CSIT_DIR - Path to existing root of local CSIT git repository.
631     # - ARCHIVE_DIR - Path to store robot result files in.
632     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
633     # - GENERATED_DIR - Tests are assumed to be generated under there.
634     # Variables set:
635     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
636     # Functions called:
637     # - die - Print to stderr and exit.
638
639     set -exuo pipefail
640
641     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
642     all_options+=("--noncritical" "EXPECTED_FAILING")
643     all_options+=("${EXPANDED_TAGS[@]}")
644
645     pushd "${CSIT_DIR}" || die "Change directory operation failed."
646     set +e
647     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
648     PYBOT_EXIT_STATUS="$?"
649     set -e
650
651     # Generate INFO level output_info.xml for post-processing.
652     all_options=("--loglevel" "INFO")
653     all_options+=("--log" "none")
654     all_options+=("--report" "none")
655     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
656     all_options+=("${ARCHIVE_DIR}/output.xml")
657     rebot "${all_options[@]}" || true
658     popd || die "Change directory operation failed."
659 }
660
661
662 function select_arch_os () {
663
664     # Set variables affected by local CPU architecture and operating system.
665     #
666     # Variables set:
667     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
668     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
669     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
670
671     set -exuo pipefail
672
673     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
674         die "Get OS release failed."
675     }
676
677     case "${os_id}" in
678         "ubuntu"*)
679             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
680             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
681             PKG_SUFFIX="deb"
682             ;;
683         "centos"*)
684             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
685             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
686             PKG_SUFFIX="rpm"
687             ;;
688         *)
689             die "Unable to identify distro or os from ${os_id}"
690             ;;
691     esac
692
693     arch=$(uname -m) || {
694         die "Get CPU architecture failed."
695     }
696
697     case "${arch}" in
698         "aarch64")
699             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
700             ;;
701         *)
702             ;;
703     esac
704 }
705
706
707 function select_tags () {
708
709     # Variables read:
710     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
711     # - TEST_CODE - String affecting test selection, usually jenkins job name.
712     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
713     #   Can be unset.
714     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
715     # - BASH_FUNCTION_DIR - Directory with input files to process.
716     # Variables set:
717     # - TAGS - Array of processed tag boolean expressions.
718
719     set -exuo pipefail
720
721     # NIC SELECTION
722     start_pattern='^  TG:'
723     end_pattern='^ \? \?[A-Za-z0-9]\+:'
724     # Remove the TG section from topology file
725     sed_command="/${start_pattern}/,/${end_pattern}/d"
726     # All topologies DUT NICs
727     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
728                 | grep -hoP "model: \K.*" | sort -u)
729     # Selected topology DUT NICs
730     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
731                | grep -hoP "model: \K.*" | sort -u)
732     # All topologies DUT NICs - Selected topology DUT NICs
733     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
734         die "Computation of excluded NICs failed."
735     }
736
737     # Select default NIC tag.
738     case "${TEST_CODE}" in
739         *"3n-dnv"* | *"2n-dnv"*)
740             default_nic="nic_intel-x553"
741             ;;
742         *"3n-tsh"*)
743             default_nic="nic_intel-x520-da2"
744             ;;
745         *"3n-skx"* | *"2n-skx"* | *"2n-clx"*)
746             default_nic="nic_intel-xxv710"
747             ;;
748         *"3n-hsw"* | *"mrr-daily-master")
749             default_nic="nic_intel-xl710"
750             ;;
751         *)
752             default_nic="nic_intel-x710"
753             ;;
754     esac
755
756     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
757     sed_nics_sub_cmd="sed -e s/ANDxxv710/ANDnic_intel-xxv710/"
758     sed_nics_sub_cmd+=" | sed -e s/ANDx710/ANDnic_intel-x710/"
759     sed_nics_sub_cmd+=" | sed -e s/ANDxl710/ANDnic_intel-xl710/"
760     sed_nics_sub_cmd+=" | sed -e s/ANDx520-da2/ANDnic_intel-x520-da2/"
761     sed_nics_sub_cmd+=" | sed -e s/ANDx553/ANDnic_intel-x553/"
762     sed_nics_sub_cmd+=" | sed -e s/ANDcx556a/ANDnic_mellanox-cx556a/"
763     sed_nics_sub_cmd+=" | sed -e s/ANDvic1227/ANDnic_cisco-vic-1227/"
764     sed_nics_sub_cmd+=" | sed -e s/ANDvic1385/ANDnic_cisco-vic-1385/"
765     # Tag file directory shorthand.
766     tfd="${BASH_FUNCTION_DIR}"
767     case "${TEST_CODE}" in
768         # Select specific performance tests based on jenkins job type variable.
769         *"ndrpdr-weekly"* )
770             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
771             ;;
772         *"mrr-daily"* )
773             readarray -t test_tag_array <<< $(sed 's/ //g' \
774                 ${tfd}/mrr-daily-${NODENESS}-${FLAVOR}.txt |
775                 eval ${sed_nics_sub_cmd}) || die
776             ;;
777         *"mrr-weekly"* )
778             readarray -t test_tag_array <<< $(${sed_nic_sub_cmd} \
779                 ${tfd}/mrr-weekly.txt) || die
780             ;;
781         * )
782             if [[ -z "${TEST_TAG_STRING-}" ]]; then
783                 # If nothing is specified, we will run pre-selected tests by
784                 # following tags.
785                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
786                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
787                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
788                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
789                                 "!dot1q" "!drv_avf")
790             else
791                 # If trigger contains tags, split them into array.
792                 test_tag_array=(${TEST_TAG_STRING//:/ })
793             fi
794             ;;
795     esac
796
797     # Blacklisting certain tags per topology.
798     #
799     # Reasons for blacklisting:
800     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
801     # TODO: Add missing reasons here (if general) or where used (if specific).
802     case "${TEST_CODE}" in
803         *"2n-skx"*)
804             test_tag_array+=("!ipsechw")
805             ;;
806         *"3n-skx"*)
807             test_tag_array+=("!ipsechw")
808             # Not enough nic_intel-xxv710 to support double link tests.
809             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
810             ;;
811         *"2n-clx"*)
812             test_tag_array+=("!ipsechw")
813             ;;
814         *"2n-dnv"*)
815             test_tag_array+=("!ipsechw")
816             test_tag_array+=("!memif")
817             test_tag_array+=("!srv6_proxy")
818             test_tag_array+=("!vhost")
819             test_tag_array+=("!vts")
820             test_tag_array+=("!drv_avf")
821             ;;
822         *"3n-dnv"*)
823             test_tag_array+=("!memif")
824             test_tag_array+=("!srv6_proxy")
825             test_tag_array+=("!vhost")
826             test_tag_array+=("!vts")
827             test_tag_array+=("!drv_avf")
828             ;;
829         *"3n-tsh"*)
830             # 3n-tsh only has x520 NICs which don't work with AVF
831             test_tag_array+=("!drv_avf")
832             test_tag_array+=("!ipsechw")
833             ;;
834         *"3n-hsw"*)
835             # TODO: Introduce NOIOMMU version of AVF tests.
836             # TODO: Make (both) AVF tests work on Haswell,
837             # or document why (some of) it is not possible.
838             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
839             test_tag_array+=("!drv_avf")
840             # All cards have access to QAT. But only one card (xl710)
841             # resides in same NUMA as QAT. Other cards must go over QPI
842             # which we do not want to even run.
843             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
844             ;;
845         *)
846             # Default to 3n-hsw due to compatibility.
847             test_tag_array+=("!drv_avf")
848             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
849             ;;
850     esac
851
852     # We will add excluded NICs.
853     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
854
855     TAGS=()
856
857     # We will prefix with perftest to prevent running other tests
858     # (e.g. Functional).
859     prefix="perftestAND"
860     set +x
861     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
862         # Automatic prefixing for VPP jobs to limit the NIC used and
863         # traffic evaluation to MRR.
864         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
865             prefix="${prefix}mrrAND"
866         else
867             prefix="${prefix}mrrAND${default_nic}AND"
868         fi
869     fi
870     for tag in "${test_tag_array[@]}"; do
871         if [[ "${tag}" == "!"* ]]; then
872             # Exclude tags are not prefixed.
873             TAGS+=("${tag}")
874         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
875             # Badly formed tag expressions can trigger way too much tests.
876             set -x
877             warn "The following tag expression hints at bad trigger: ${tag}"
878             warn "Possible cause: Multiple triggers in a single comment."
879             die "Aborting to avoid triggering too many tests."
880         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
881             # Empty and comment lines are skipped.
882             # Other lines are normal tags, they are to be prefixed.
883             TAGS+=("${prefix}${tag}")
884         fi
885     done
886     set -x
887 }
888
889
890 function select_topology () {
891
892     # Variables read:
893     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
894     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
895     # - CSIT_DIR - Path to existing root of local CSIT git repository.
896     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
897     # Variables set:
898     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
899     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
900     # Functions called:
901     # - die - Print to stderr and exit.
902
903     set -exuo pipefail
904
905     case_text="${NODENESS}_${FLAVOR}"
906     case "${case_text}" in
907         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
908         # TODO: Double link availability depends on NIC used.
909         "1n_vbox")
910             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
911             TOPOLOGIES_TAGS="2_node_single_link_topo"
912             ;;
913         "1n_skx" | "1n_tx2")
914             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
915             TOPOLOGIES_TAGS="2_node_single_link_topo"
916             ;;
917         "2n_skx")
918             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
919             TOPOLOGIES_TAGS="2_node_*_link_topo"
920             ;;
921         "3n_skx")
922             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
923             TOPOLOGIES_TAGS="3_node_*_link_topo"
924             ;;
925         "2n_clx")
926             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
927             TOPOLOGIES_TAGS="2_node_*_link_topo"
928             ;;
929         "2n_dnv")
930             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
931             TOPOLOGIES_TAGS="2_node_single_link_topo"
932             ;;
933         "3n_dnv")
934             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
935             TOPOLOGIES_TAGS="3_node_single_link_topo"
936             ;;
937         "3n_hsw")
938             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
939             TOPOLOGIES_TAGS="3_node_single_link_topo"
940             ;;
941         "3n_tsh")
942             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
943             TOPOLOGIES_TAGS="3_node_single_link_topo"
944             ;;
945         *)
946             # No falling back to 3n_hsw default, that should have been done
947             # by the function which has set NODENESS and FLAVOR.
948             die "Unknown specification: ${case_text}"
949     esac
950
951     if [[ -z "${TOPOLOGIES-}" ]]; then
952         die "No applicable topology found!"
953     fi
954 }
955
956
957 function select_vpp_device_tags () {
958
959     # Variables read:
960     # - TEST_CODE - String affecting test selection, usually jenkins job name.
961     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
962     #   Can be unset.
963     # Variables set:
964     # - TAGS - Array of processed tag boolean expressions.
965
966     set -exuo pipefail
967
968     case "${TEST_CODE}" in
969         # Select specific device tests based on jenkins job type variable.
970         * )
971             if [[ -z "${TEST_TAG_STRING-}" ]]; then
972                 # If nothing is specified, we will run pre-selected tests by
973                 # following tags. Items of array will be concatenated by OR
974                 # in Robot Framework.
975                 test_tag_array=()
976             else
977                 # If trigger contains tags, split them into array.
978                 test_tag_array=(${TEST_TAG_STRING//:/ })
979             fi
980             ;;
981     esac
982
983     # Blacklisting certain tags per topology.
984     #
985     # Reasons for blacklisting:
986     # - avf - AVF is not possible to run on enic driver of VirtualBox.
987     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
988     case "${TEST_CODE}" in
989         *"1n-vbox"*)
990             test_tag_array+=("!avf")
991             test_tag_array+=("!vhost")
992             ;;
993         *)
994             ;;
995     esac
996
997     TAGS=()
998
999     # We will prefix with devicetest to prevent running other tests
1000     # (e.g. Functional).
1001     prefix="devicetestAND"
1002     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1003         # Automatic prefixing for VPP jobs to limit testing.
1004         prefix="${prefix}"
1005     fi
1006     for tag in "${test_tag_array[@]}"; do
1007         if [[ ${tag} == "!"* ]]; then
1008             # Exclude tags are not prefixed.
1009             TAGS+=("${tag}")
1010         else
1011             TAGS+=("${prefix}${tag}")
1012         fi
1013     done
1014 }
1015
1016 function untrap_and_unreserve_testbed () {
1017
1018     # Use this as a trap function to ensure testbed does not remain reserved.
1019     # Perhaps call directly before script exit, to free testbed for other jobs.
1020     # This function is smart enough to avoid multiple unreservations (so safe).
1021     # Topo cleanup is executed (call it best practice), ignoring failures.
1022     #
1023     # Hardcoded values:
1024     # - default message to die with if testbed might remain reserved.
1025     # Arguments:
1026     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1027     # Variables read (by inner function):
1028     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1029     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1030     # Variables written:
1031     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1032     # Trap unregistered:
1033     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1034     # Functions called:
1035     # - die - Print to stderr and exit.
1036     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1037
1038     set -xo pipefail
1039     set +eu  # We do not want to exit early in a "teardown" function.
1040     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1041     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1042     if [[ -z "${wt-}" ]]; then
1043         set -eu
1044         warn "Testbed looks unreserved already. Trap removal failed before?"
1045     else
1046         ansible_playbook "cleanup" || true
1047         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1048             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1049         }
1050         WORKING_TOPOLOGY=""
1051         set -eu
1052     fi
1053 }
1054
1055
1056 function warn () {
1057
1058     # Print the message to standard error.
1059     #
1060     # Arguments:
1061     # - ${@} - The text of the message.
1062
1063     set -exuo pipefail
1064
1065     echo "$@" >&2
1066 }